using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;

using GDI_capturar_regiones;

namespace GDI_capturar_regiones
{
	//Imports System.IO
	
	public class Captura : System.Windows.Forms.Form
	{
		
#region Default Instance
		
		private static Captura defaultInstance;
		
		/// <summary>
		/// Added by the VB.Net to C# Converter to support default instance behavour in C#
		/// </summary>
		public static Captura Default
		{
			get
			{
				if (defaultInstance == null)
				{
					defaultInstance = new Captura();
					defaultInstance.FormClosed += new System.Windows.Forms.FormClosedEventHandler(defaultInstance_FormClosed);
				}
				
				return defaultInstance;
			}
			set
			{
				defaultInstance = value;
			}
		}
		
		static void defaultInstance_FormClosed(object sender, System.Windows.Forms.FormClosedEventArgs e)
		{
			defaultInstance = null;
		}
		
#endregion
		
#region  Código generado por el Diseñador de Windows Forms
		
		public Captura()
		{
			
			//El Diseñador de Windows Forms requiere esta llamada.
			InitializeComponent();
			
			//Added to support default instance behavour in C#
			if (defaultInstance == null)
				defaultInstance = this;
			
			//Agregar cualquier inicialización después de la llamada a InitializeComponent()
			
		}
		
		//Form reemplaza a Dispose para limpiar la lista de componentes.
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (!(ReferenceEquals(components, null)))
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

        private System.ComponentModel.IContainer components;

        //NOTA: el Diseñador de Windows Forms requiere el siguiente procedimiento
        //Puede modificarse utilizando el Diseñador de Windows Forms.
        //No lo modifique con el editor de código.
        internal System.Windows.Forms.PictureBox PBox1;
		internal System.Windows.Forms.Button btCerrar;
		internal System.Windows.Forms.Button btWin1;
		internal System.Windows.Forms.Button btWin2;
		internal System.Windows.Forms.Button btRegion;
		internal Button BtCapturas;
		internal System.Windows.Forms.ToolTip ToolTip1;
		[System.Diagnostics.DebuggerStepThrough()]private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Captura));
            this.PBox1 = new System.Windows.Forms.PictureBox();
            this.btCerrar = new System.Windows.Forms.Button();
            this.btWin1 = new System.Windows.Forms.Button();
            this.btWin2 = new System.Windows.Forms.Button();
            this.btRegion = new System.Windows.Forms.Button();
            this.ToolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.BtCapturas = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.PBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // PBox1
            // 
            this.PBox1.Image = ((System.Drawing.Image)(resources.GetObject("PBox1.Image")));
            this.PBox1.Location = new System.Drawing.Point(12, 7);
            this.PBox1.Name = "PBox1";
            this.PBox1.Size = new System.Drawing.Size(267, 267);
            this.PBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
            this.PBox1.TabIndex = 0;
            this.PBox1.TabStop = false;
            // 
            // btCerrar
            // 
            this.btCerrar.BackColor = System.Drawing.Color.White;
            this.btCerrar.Cursor = System.Windows.Forms.Cursors.Hand;
            this.btCerrar.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btCerrar.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btCerrar.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btCerrar.Location = new System.Drawing.Point(188, 311);
            this.btCerrar.Name = "btCerrar";
            this.btCerrar.Size = new System.Drawing.Size(64, 21);
            this.btCerrar.TabIndex = 3;
            this.btCerrar.Text = "Cerrar";
            this.ToolTip1.SetToolTip(this.btCerrar, "Salir de la aplicación");
            this.btCerrar.UseVisualStyleBackColor = false;
            this.btCerrar.Click += new System.EventHandler(this.btCerrar_Click);
            // 
            // btWin1
            // 
            this.btWin1.BackColor = System.Drawing.Color.White;
            this.btWin1.Cursor = System.Windows.Forms.Cursors.Hand;
            this.btWin1.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btWin1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btWin1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btWin1.Location = new System.Drawing.Point(13, 284);
            this.btWin1.Name = "btWin1";
            this.btWin1.Size = new System.Drawing.Size(84, 21);
            this.btWin1.TabIndex = 0;
            this.btWin1.Text = "Formulario";
            this.ToolTip1.SetToolTip(this.btWin1, "Capturar la ventana con bodes y decoración");
            this.btWin1.UseVisualStyleBackColor = false;
            this.btWin1.Click += new System.EventHandler(this.btWin1_Click);
            // 
            // btWin2
            // 
            this.btWin2.BackColor = System.Drawing.Color.White;
            this.btWin2.Cursor = System.Windows.Forms.Cursors.Hand;
            this.btWin2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btWin2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btWin2.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btWin2.Location = new System.Drawing.Point(103, 284);
            this.btWin2.Name = "btWin2";
            this.btWin2.Size = new System.Drawing.Size(84, 21);
            this.btWin2.TabIndex = 1;
            this.btWin2.Text = "Área cliente";
            this.ToolTip1.SetToolTip(this.btWin2, "Capturar la ventana sin decoración (área cliente)");
            this.btWin2.UseVisualStyleBackColor = false;
            this.btWin2.Click += new System.EventHandler(this.btWin2_Click);
            // 
            // btRegion
            // 
            this.btRegion.BackColor = System.Drawing.Color.White;
            this.btRegion.Cursor = System.Windows.Forms.Cursors.Hand;
            this.btRegion.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btRegion.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.btRegion.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.btRegion.Location = new System.Drawing.Point(193, 284);
            this.btRegion.Name = "btRegion";
            this.btRegion.Size = new System.Drawing.Size(84, 21);
            this.btRegion.TabIndex = 2;
            this.btRegion.Text = "PictureBox";
            this.ToolTip1.SetToolTip(this.btRegion, "Capturar s�lo la región del PictureBox");
            this.btRegion.UseVisualStyleBackColor = false;
            this.btRegion.Click += new System.EventHandler(this.btRegion_Click);
            // 
            // BtCapturas
            // 
            this.BtCapturas.BackColor = System.Drawing.Color.White;
            this.BtCapturas.Cursor = System.Windows.Forms.Cursors.Hand;
            this.BtCapturas.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.BtCapturas.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.BtCapturas.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.BtCapturas.Location = new System.Drawing.Point(38, 311);
            this.BtCapturas.Name = "BtCapturas";
            this.BtCapturas.Size = new System.Drawing.Size(144, 21);
            this.BtCapturas.TabIndex = 4;
            this.BtCapturas.Text = "Mostrar las capturas";
            this.ToolTip1.SetToolTip(this.BtCapturas, "Mostrar las 3 imágenes capturadas");
            this.BtCapturas.UseVisualStyleBackColor = false;
            this.BtCapturas.Click += new System.EventHandler(this.BtCapturas_Click);
            // 
            // Captura
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi;
            this.CancelButton = this.btCerrar;
            this.ClientSize = new System.Drawing.Size(290, 346);
            this.Controls.Add(this.BtCapturas);
            this.Controls.Add(this.btRegion);
            this.Controls.Add(this.btWin2);
            this.Controls.Add(this.btWin1);
            this.Controls.Add(this.btCerrar);
            this.Controls.Add(this.PBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Captura";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Captura y recorte C#";
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.Captura_Paint);
            ((System.ComponentModel.ISupportInitialize)(this.PBox1)).EndInit();
            this.ResumeLayout(false);

		}
		
#endregion
		
	// Como dice Arbis Percy Reyes en uno de sus artículos:
    // GDI+ es una interfaz de programación de aplicaciones (API) que se expone a través de un conjunto de clases implementadas 
    // como código administrado. GDI+ viene a ser la interfaz de dispositivo gráfico que se encarga de mostrar información en pantallas
    // e impresoras, la cual nos permite a nosotros, como programadores de aplicaciones, mostrar información en una pantalla o impresora 
    // sin tener que preocuparnos por los detalles de un dispositivo de presentación específico, es decir, cuando desarrollemos aplicaciones 
    // usando los métodos suministrados por las clases de GDI+, no tendremos que preocuparnos por el hardware gráfico, ya que 
    // todo este trabajo lo harán los métodos GDI+ llamando a los controladores de dispositivo específicos, de esta manera GDI+ separa 
    // la aplicación del hardware gráfico, y esta separación es la que nos permite crear aplicaciones independientes del dispositivo. 
    // Ahora podemos decir con seguridad que GDI+ es una interfaz de dispositivo gráfico que permite a los programadores 
    // escribir aplicaciones independientes del dispositivo.

    // VentanaA, VentanaB y VentanaC obtienen un objeto Graphics para el formulario / el área cliente / el control PictureBox y también se crea un Bitmap 
    // de tamaño adecuado para contener la imagen. Obtienen los enlaces de los contextos de dispositivo (device context handle - Hdc) 
    // para los objetos Graphics y usan la función BitBlt (BitBlast) para copiar la imagen en el Bitmap.
    // BitBlt deriva de la instrucción BitBLT (bit block transfer, transferencia de bloque de bits) y consiste en la transferencia de un bloque de bits 
    // que se corresponden con un rectángulo de píxeles desde un DC origen a un DC destino- En resumen se trata de combinar dos mapas de bits en uno solo

    // Parámetros de la función BitBlt:
    // - hdcDest: apunta al contexto de dispositivo (DC) destino
    // - nXDest: coordenada x de la esquina superior izquierda del rectángulo destino
    // - nYDest: coordenada y de la esquina superior izquierda del rectángulo destino
    // - nWidth: anchura del rectángulo destino (ha de ser igual al origen)
    // - nHeight: altura del rectángulo destino (ha de ser igual al origen)
    // - hdcSrc: apunta al contexto de dispositivo (DC) origen
    // - nXSrc: coordenada x de la esquina superior izquierda del rectángulo origen
    // - nYSrc: coordenada y de la esquina superior izquierda del rectángulo origen
    // - dwRop: código de operación de rastreo, define la manera en que los datos del origen se combinan con los del destino. Define cómo se combinan
    // los colores en el rectángulo de salida para obtener el color final. Aquí se usa SRCCOPY que copia el rectángulo de origen directamente en el rectángulo de destino 

    // En esta aplicación se usa el tipo de dato IntPtr. Se ha diseñado el tipo IntPtr para que sea un número entero cuyo tamaño sea específico
    // de la plataforma. Es decir, se espera que una instancia de este tipo tenga lugar en sistemas operativos y hardware de 32 bits, y en sistemas
    // operativos y hardware de 64 bits. El tipo IntPtr se puede utilizar como un medio común para hacer referencia a los datos entre idiomas
    // (admitan o no punteros). El tipo IntPtr es compatible con CLS (Common Language Specification) -> conjunto de características
    // básicas de lenguaje englobadas en .NET Framework. El tipo IntPtr pertenece al espacio de nombres System.

    // Importación de librerías externas de la API de  Windows
		
		[System.Runtime.InteropServices.DllImport("gdi32.dll")]
			public static  extern bool BitBlt(IntPtr hdcDest, int nXDest, int nYDest, int nWidth, int nHeight, IntPtr hdcSrc, int nXSrc, int nYSrc, System.Int32 dwRop);
		
		// GetWindowDC devuelve el contexto de dispositivo (DC) correspondiente a la ventana entera, con bordes, barras de herramientas, de menús y de scroll, etc.
		// Un DC de la ventana permite pintar sobre la ventana ya que el origen del DC es la esquina superior izda. de la ventana y no la esquina superior izda. del área cliente
		[System.Runtime.InteropServices.DllImport("User32.dll")]
			public static  extern System.IntPtr GetWindowDC(System.IntPtr hwnd);
		
		// Constante para usar como último parámetro de la función BitBlt
		private const int SRCCOPY = 0xCC0020; //destino = origen
		
		// Librerías externas de la API de  Windows que no se necesitan
		
		//<System.Runtime.InteropServices.DllImport("User32.dll")>
		//Public Shared Function GetDC(ByVal hWnd As System.Int32) As System.IntPtr()
		//End Function
		
		//<System.Runtime.InteropServices.DllImport("gdi32.dll")>
		//Public Shared Function CreateCompatibleDC(ByVal hdc As Long) As Long
		//End Function
		
		//<System.Runtime.InteropServices.DllImport("gdi32.dll")>
		//Public Shared Function DeleteDC(ByVal hdc As Long) As Long
		//End Function
		
		//<System.Runtime.InteropServices.DllImport("gdi32.dll")>
		//Public Shared Function SelectObject(ByVal hdc As Long, ByVal hObject As Long) As Long
		//End Function
		
		//ACTUAMOS EN EL EVENTO PAINT DEL FORMULARIO
		// El evento Paint se produce cada vez que se dibuja el formulario o cualquier otro control
		// Aquí se rellena el PictureBox con la imagen elegida recortando sobre ella un círculo
		// para crear la ventana del formulario que será copiada de formas diferentes y guardada como archivos JPG
		private void Captura_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			// Podemos mejorar el aspecto del borde redondeado aplicando antialias
			// Graphics.SmoothingMode obtiene o establece la calidad de la representación del objeto Graphics
			e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
			// Creamos un objeto de la clase GraphicsPath que representa una serie de líneas y curvas conectadas
			GraphicsPath curra = new GraphicsPath();
			// Manipulando las variables que se corresponden con los puntos x.y, ancho y alto de la figura podemos variar su aspecto
			int x = 0;
			int y = 0;
			int ancho = 0;
			int alto = 0;
			// Posiciones x.y del objeto curra (las del control PictureBox)
			x = PBox1.Left;
			y = PBox1.Top;
			// Anchura y altura del objeto curra, un poco menores que las del PictureBox para que se vea bien ajustado al control
			ancho = PBox1.Width - 24;
			alto = PBox1.Height - 24;
			// Usamos el método AddEllipse para agregar la forma de un círculo o elipse al trazado actual (el control PictureBox)
			curra.AddEllipse(new Rectangle(x, y, ancho, alto));
			// En el PictureBox creamos una región que se corresponde con la forma del objeto GraphicsPath (círculo)
			// y se dibuja en el PictureBox asignando el objeto curra a la región
			// Region de System.Drawing describe el interior de una forma gráfica formada por rectángulos y trazados
			Region reg = default(Region);
			reg = new Region(curra);
			PBox1.Region = reg;
			// Otra forma de realizarlo
			//pBox.Region = New Region(curra)
		}
		
		//GUARDAR LA VENTANA Y SUS BORDES COMO JPG
		private void btWin1_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				Bitmap bm = imagenFormA();
				bm.Save(Application.StartupPath + "\\Ventana1.jpg", ImageFormat.Jpeg);
			}
			catch (Exception pollo)
			{
				MessageBox.Show("ERROR: " + pollo.Message,"Aviso");
			}
		}
		
		//GUARDAR LA VENTANA SIN BORDES COMO JPG
		private void btWin2_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				Bitmap bm = imagenFormB();
				bm.Save(Application.StartupPath + "\\Ventana2.jpg", ImageFormat.Jpeg);
			}
			catch (Exception pollo)
			{
                MessageBox.Show("ERROR: " + pollo.Message, "Aviso");
            }
        }
		
		//GUARDAR LA REGIÓN DEL PICTUREBOX COMO JPG
		private void btRegion_Click(System.Object sender, System.EventArgs e)
		{
			try
			{
				Bitmap bm = imagenFormC();
				bm.Save(Application.StartupPath + "\\Ventana3.jpg", ImageFormat.Jpeg);
			}
			catch (Exception pollo)
			{
                MessageBox.Show("ERROR: " + pollo.Message, "Aviso");
            }
        }
		
		//OBTENER UN BITMAP CON LA IMAGEN DE LA VENTANA CON DECORACIÓN
		private Bitmap imagenFormA()
		{
			try
			{

                // UNA FORMA DE OBTENER LA VENTANA COMPLETA CON BORDES Y DECORACIÓN SIN USAR GDI+
                //enviar la pulsación equivalente a Alt + ImprPant
                SendKeys.SendWait("%{PRTSC}");
                //tiempo de espera
                System.Threading.Thread.Sleep(500);
                //enviar la pulsación equivalente a Alt + ImprPant
                SendKeys.SendWait("%{PRTSC}");
                //capturar, guardar y mostrar la captura en el PictureBox
                Bitmap bm = default(Bitmap);
                bm = (Bitmap)(Clipboard.GetDataObject().GetData("Bitmap"));
                return bm;

                //// UNA FORMA DE OBTENER LA VENTANA COMPLETA CON BORDES Y DECORACIÓN USANDO GDI+
                //// Objeto Graphics de origen para tener área de dibujo y Bitmap para contener la imagen (anchura y altura del área del formulario)
                //Graphics g1 = this.CreateGraphics();
                //Bitmap bm = new Bitmap(this.Width, this.Height, g1);
                //// Objeto Graphics de destino (desde el Bitmap bm generado a partir del primer objeto Graphics)
                //Graphics g2 = Graphics.FromImage(bm);
                //// Un device context (DC) es una estructura  que define un conjunto de objetos gráficos y sus atributos asociados
                //// IntPtr es un entero específico de la plataforma (específico del sistema operativo de 32 o de 64 bits)
                //// Hdc es device context handle (enlace al contexto de dispositivo del objeto g2)
                //IntPtr bm_Hdc = g2.GetHdc();
                //// Hdc de toda la ventana, se debe hacer después de crear el Bitmap (utiliza g1)
                //IntPtr me_Hdc = GetWindowDC(this.Handle);
                //// Copiar la imagen del área del formulario en el Bitmap, rectángulos origen y destino tienen coordenadas x.y = 0
                //BitBlt(bm_Hdc, 0, 0, this.Width, this.Height, me_Hdc, 0, 0, SRCCOPY);
                //// Liberar recursos (Hdc de la ventana que es g1 no se debe liberar todavía pues en caso contrario se pierde
                //// la referencia a la ventana al devolver el resultado (Return Bm) y da error al compilar)
                //g2.ReleaseHdc(bm_Hdc);
                //// Devolver el resultado
                //return bm;
                //g1.ReleaseHdc(me_Hdc);

                //// OTRA FORMA DE OBTENER LA VENTANA COMPLETA CON BORDES Y DECORACIÓN USANDO GDI+
                //// SÓLO FUNCIONA BIEN SI EL ESCALADO DE LA PANTALLA DEL ORDENADOR ESTÁ EN 100%
                //// Objeto Graphics de origen para tener área de dibujo (desde la ventana del formulario)
                //Graphics g1 = this.CreateGraphics();
                //// Tamaño del formulario que deseamos copiar
                //Size medidas = this.Size;
                //// Bitmap para contener la imagen, en este caso con el tamaño del formulario actual
                //// New Bitmap(Int32, Int32, Graphics)  inicializa una nueva instancia de la clase Bitmap con:
                //// - el tamaño especificado (medidas.Width, medidas.Height)
                //// - la resolución del objeto Graphics especificado (g1)
                //Bitmap bm = new Bitmap(medidas.Width, medidas.Height, g1);
                //// Crear otro objeto Graphics a partir del bitmap generado
                //Graphics g2 = Graphics.FromImage(bm);
                //// Copiar el área de la pantalla ocupada por el formulario
                //// el método Graphics.CopyFromScreen(Int32, Int32, Int32, Int32, Size) transfiere un bloque de bits
                //// correspondientes a un rectángulo de píxeles, desde la pantalla a la superficie de dibujo de Graphics
                //// CopyFromScreen (int sourceX, int sourceY, int destinationX, int destinationY, System.Drawing.Size blockRegionSize)
                //g2.CopyFromScreen(this.Location.X, this.Location.Y, 0, 0, medidas);
                //// Devolver el resultado
                //return bm;

            }
            catch (Exception pollo)
			{
                MessageBox.Show("ERROR: " + pollo.Message, "Aviso");
            }
            return default(Bitmap);
		}
		
		//OBTENER UN BITMAP CON LA IMAGEN DE LA VENTANA SIN DECORACIÓN (ÁREA CLIENTE)
		private Bitmap imagenFormB()
		{
			try
			{
				// Objeto Graphics de origen para tener área de dibujo y Bitmap para contener la imagen (anchura y altura del área cliente del formulario)
				Graphics g1 = this.CreateGraphics();
				Bitmap bm = new Bitmap(this.ClientSize.Width, this.ClientSize.Height, g1);
				// Objeto Graphics de destino (desde el Bitmap bm generado a partir del primer objeto Graphics)
				Graphics g2 = Graphics.FromImage(bm);
				// Un device context (DC) es una estructura  que define un conjunto de objetos gráficos y sus atributos asociados
				// IntPtr es un entero específico de la plataforma (específico del sistema operativo de 32 o de 64 bits)
				// Hdc es device context handle (enlace al contexto de dispositivo del objeto g2)
				IntPtr bm_Hdc = g2.GetHdc();
				// Hdc de toda la ventana, se debe hacer después de crear el Bitmap (utiliza g1)
				IntPtr me_Hdc = g1.GetHdc();
				// Copiar la imagen del área del formulario en el Bitmap, rectángulos origen y destino tienen coordenadas x.y = 0
				// BitBlt deriva de la instrucción BitBLT (bit block transfer, transferencia de bloque de bits) y consiste en la transferencia
				// de un bloque de bits que se corresponden con un rectángulo de píxeles desde un DC origen a un DC destino
				// En resumen se trata de que dos mapas de bit son combinados en uno solo
				BitBlt(bm_Hdc, 0, 0, this.ClientSize.Width, this.ClientSize.Height, me_Hdc, 0, 0, SRCCOPY);
				// Liberar recursos, se puede liberar tambión la ventana
				g2.ReleaseHdc(bm_Hdc);
				g1.ReleaseHdc(me_Hdc);
				// Devolver el resultado
				return bm;
			}
			catch (Exception pollo)
			{
                MessageBox.Show("ERROR: " + pollo.Message, "Aviso");
            }
            return default(Bitmap);
		}
		
		//OBTENER UN BITMAP CON LA IMAGEN DE LA REGIÓN
		private Bitmap imagenFormC()
		{
			try
			{
				// Objeto Graphics de origen para tener área de dibujo y Bitmap para contener la imagen (anchura y altura del PictureBox)
				Graphics g1 = this.CreateGraphics();
				Bitmap bm = new Bitmap(PBox1.Width, PBox1.Height, g1);
				// Objeto Graphics de destino (desde el Bitmap bm generado a partir del primer objeto Graphics)
				Graphics g2 = Graphics.FromImage(bm);
				// Un device context (DC) es una estructura  que define un conjunto de objetos gráficos y sus atributos asociados
				// IntPtr es un entero específico de la plataforma (específico del sistema operativo de 32 o de 64 bits)
				// Hdc es device context handle (enlace al contexto de dispositivo del objeto g2)
				IntPtr bm_Hdc = g2.GetHdc();
				// Hdc de toda la ventana, se debe hacer después de crear el Bitmap (utiliza g1)
				IntPtr me_Hdc = g1.GetHdc();
				// Copiar la imagen del área del formulario en el Bitmap, rectángulos origen tiene coordenadas x.y = 0
				// pero el rectángulo destino tiene las coordenadas x.y del control PictureBox
				// BitBltderiva de la instrucción BitBLT (bit block transfer, transferencia de bloque de bits) y consiste en la transferencia
				// de un bloque de bits que se corresponden con un rectángulo de píxeles desde un DC origen a un DC destino
				// En resumen se trata de que dos mapas de bit son combinados en uno solo
				BitBlt(bm_Hdc, 0, 0, this.PBox1.Width, this.PBox1.Height, me_Hdc, PBox1.Left, PBox1.Top, SRCCOPY);
				// Liberar recursos, se puede liberar tambión la ventana
				g2.ReleaseHdc(bm_Hdc);
				g1.ReleaseHdc(me_Hdc);
				// Devolver el resultado
				return bm;
			}
			catch (Exception pollo)
			{
                MessageBox.Show("ERROR: " + pollo.Message, "Aviso");
            }
            return default(Bitmap);
		}
		
		// Abrir una instancia del formulario Ventanas en el que se muestran las 3 imágenes capturadas (formulario con bordes,
		// formulario sin bordes o área cliente y control de imagen) en 3 PictureBox diferentes adaptados al tamaño de las imágenes
		private void BtCapturas_Click(object sender, EventArgs e)
		{
			Ventanas F1 = new Ventanas();
			F1.Show();
			this.Close();
		}
		
		// Cerrar el formulario
		private void btCerrar_Click(System.Object sender, System.EventArgs e)
		{
			this.Close();
		}
		
	}
	
}
